#include "resource.h"
#include <Windows.h>

typedef struct
{
   ULONG pipeNum;
}
BULK_TRANSFER_CONTROL;

HINSTANCE g_hInst;
bool g_bScopeConnected = false;

bool ScopeExecute(HANDLE hScope, const char *commandLine)
{
	char readBuffer[512];
	char buffer [512];
	char *buffPtr = buffer;
	int packetLength = 2 + strlen(commandLine), checkSum = 0x43 + 0x11 + (packetLength & 0xFF) + ((packetLength & 0xFF00) >> 8);

	*buffPtr++ = 0x43;
	*buffPtr++ = packetLength & 0xFF;
	*buffPtr++ = (packetLength & 0xFF00) >> 8;
	*buffPtr++ = 0x11;
	
	while(*commandLine != '\0')
	{
		checkSum += *commandLine;
		*buffPtr++ = *commandLine++;
	}

	*buffPtr++ = checkSum & 0xFF;

	BULK_TRANSFER_CONTROL vReq;
	vReq.pipeNum = 0;

	unsigned long byteCount;
	if(DeviceIoControl(hScope, 0x22200D, &vReq, sizeof(BULK_TRANSFER_CONTROL), buffer, packetLength+3, &byteCount, NULL))
	{
		vReq.pipeNum = 1;

		if(DeviceIoControl(hScope, 0x222012, &vReq, sizeof(BULK_TRANSFER_CONTROL), readBuffer, sizeof(readBuffer), &byteCount, NULL))
			return(true);
	}

	return(false);
}

HANDLE ScopeConnect()
{
	HANDLE hScope = CreateFile("\\\\.\\Ezusb-0", GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	return(hScope);
}

int WINAPI DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		HANDLE hIcon;
		hIcon = LoadImage(g_hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON,
			GetSystemMetrics(SM_CXSMICON),
			GetSystemMetrics(SM_CYSMICON),
			0);
		if(hIcon)
		{
			SendMessage(hwndDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
		}

		AppendMenu(GetSystemMenu(hwndDlg, false), MF_SEPARATOR, 0, "");
		AppendMenu(GetSystemMenu(hwndDlg, false), MF_BYPOSITION, 200, "About");

		SetTimer(hwndDlg, 1, 500, NULL);
		return(true);

	case WM_CLOSE:
		EndDialog(hwndDlg, 0);
		return(true);

	case WM_COMMAND:
		switch(wParam)
		{
		case IDCANCEL:
			EndDialog(hwndDlg, 0);
			return(true);

		case IDGO:
			KillTimer(hwndDlg, 1);
			char shellcmd[255];
			GetDlgItemTextA(hwndDlg, IDC_EDIT, shellcmd, sizeof(shellcmd));
			
			EnableWindow(GetDlgItem(hwndDlg, IDGO), 0);
			SetWindowText(GetDlgItem(hwndDlg, IDGO), "Executing...");
			UpdateWindow(GetDlgItem(hwndDlg, IDGO));

			HANDLE hScope = ScopeConnect();
			if(hScope == INVALID_HANDLE_VALUE)
			{
				MessageBox(hwndDlg, "Failed to connect to scope.",
					"Error",
					MB_ICONERROR|MB_OK);
			}
			else
			{
				if(ScopeExecute(hScope, shellcmd))
				{
					SetWindowText(GetDlgItem(hwndDlg, IDGO), "Execute cmd");
					UpdateWindow(GetDlgItem(hwndDlg, IDGO));
					EnableWindow(GetDlgItem(hwndDlg, IDGO), 1);
				}
				else
				{
					MessageBox(hwndDlg, "Failed to execute commands.",
						"Error",
						MB_ICONERROR|MB_OK);
					CloseHandle(hScope);
				}

				CloseHandle(hScope);
			}
			//EndDialog(hwndDlg, 0);
			return(true);
		}

		return(false);

	case WM_SYSCOMMAND:
		if(LOWORD(wParam) == 200)
		{
			MessageBox(hwndDlg, "HanTekway Shell Exec\n\nUSE AT YOUR OWN RISK.",
				"About",
				MB_ICONINFORMATION|MB_OK);
			return(true);
		}
		return(false);

	case WM_TIMER:
		HANDLE hScope = ScopeConnect();
		if(hScope == INVALID_HANDLE_VALUE)
		{
			if(g_bScopeConnected)
			{
				EnableWindow(GetDlgItem(hwndDlg, IDGO), false);
				SetWindowText(GetDlgItem(hwndDlg, IDGO), "Please connect scope");
				g_bScopeConnected = false;
			}
		}
		else
		{
			CloseHandle(hScope);

			if(!g_bScopeConnected)
			{
				EnableWindow(GetDlgItem(hwndDlg, IDGO), true);
				SetWindowText(GetDlgItem(hwndDlg, IDGO), "Execute cmd");
				g_bScopeConnected = true;
			}
		}
		return(true);
	};

	return(false);
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, DlgProc);
	return(0);
}
